Panda3D

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Static Public Member Functions | Public Attributes | Friends | List of all members
MayaNodeDesc Class Reference

Describes a single instance of a node in the Maya scene graph, relating it to the corresponding egg structures (e.g. More...

`#include "mayaNodeDesc.h"`

Inheritance diagram for MayaNodeDesc:

## Public Types
typedef pvector< PT(MayaNodeDesc) > | Children

## Public Member Functions
| MayaNodeDesc (MayaNodeTree *tree, MayaNodeDesc *parent=nullptr, const std::string &name=std::string())
void | from_dag_path (const MDagPath &dag_path, MayaToEggConverter *converter)
| Indicates an association between the MayaNodeDesc and some Maya instance.
MayaBlendDesc * | get_blend_desc (int n) const
| Returns the nth MayaBlendDesc object that affects the geometry in this node.
const MDagPath & | get_dag_path () const
| Returns the dag path associated with this node.
int | get_num_blend_descs () const
| Returns the number of unique MayaBlendDesc objects (and hence the number of morph sliders) that affect the geometry in this node.
bool | has_dag_path () const
| Returns true if a Maya dag path has been associated with this node, false otherwise.
bool | has_object_type (std::string object_type) const
| Returns true if this node or any of its parent has_object_type of object_type.
bool | is_joint () const
| Returns true if the node should be treated as a joint by the converter.
bool | is_joint_parent () const
| Returns true if the node is the parent or ancestor of a joint.
bool | is_joint_tagged () const
| Returns true if the node has been joint_tagged to be converted, false otherwise.
bool | is_tagged () const
| Returns true if the node has been tagged to be converted, false otherwise.
Public Member Functions inherited from ReferenceCount
int | get_ref_count () const
WeakReferenceList * | get_weak_list () const
| Returns the WeakReferenceList associated with this ReferenceCount object.
bool | has_weak_list () const
| Returns true if this particular ReferenceCount object has a WeakReferenceList created, false otherwise.
void | local_object ()
| This function should be called, once, immediately after creating a new instance of some ReferenceCount-derived object on the stack.
void | ref () const
| Explicitly increments the reference count.
bool | ref_if_nonzero () const
| Atomically increases the reference count of this object if it is not zero.
bool | test_ref_count_integrity () const
| Does some easy checks to make sure that the reference count isn't completely bogus.
bool | test_ref_count_nonzero () const
| Does some easy checks to make sure that the reference count isn't zero, or completely bogus.
virtual bool | unref () const
| Explicitly decrements the reference count.
bool | unref_if_one () const
| Atomically decreases the reference count of this object if it is one.
WeakReferenceList * | weak_ref ()
| Adds the indicated PointerToVoid as a weak reference to this object.
void | weak_unref ()
| Removes the indicated PointerToVoid as a weak reference to this object.
Public Member Functions inherited from MemoryBase
void | operator delete (void *, void *)
void | operator delete (void *ptr)
void | operator delete[] (void *, void *)
void | operator delete[] (void *ptr)
void * | operator new (size_t size)
void * | operator new (size_t size, void *ptr)
void * | operator new[] (size_t size)
void * | operator new[] (size_t size, void *ptr)
Public Member Functions inherited from Namable
| Namable (const std::string &initial_name="")
void | clear_name ()
| Resets the Namable's name to empty.
const std::string & | get_name () const
bool | has_name () const
| Returns true if the Namable has a nonempty name set, false if the name is empty.
void | output (std::ostream &out) const
| Outputs the Namable.
void | set_name (const std::string &name)

## Static Public Member Functions
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from ReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from Namable
static TypeHandle | get_class_type ()
static void | init_type ()

## Public Attributes
Children | _children
MayaNodeDesc * | _parent
MayaNodeTree * | _tree
Public Attributes inherited from ReferenceCount
| get_ref_count
| Returns the current reference count.
Public Attributes inherited from Namable
| get_name
| set_name

## Friends
class | MayaNodeTree

## Detailed Description

Describes a single instance of a node in the Maya scene graph, relating it to the corresponding egg structures (e.g.

node, group, or table entry) that will be created.

Definition at line 40 of file mayaNodeDesc.h.

## Member Typedef Documentation

## ◆ Children

typedef pvector< PT(MayaNodeDesc) > MayaNodeDesc::Children

Definition at line 62 of file mayaNodeDesc.h.

## Constructor & Destructor Documentation

## ◆ MayaNodeDesc()

MayaNodeDesc::MayaNodeDesc | ( | MayaNodeTree * | tree,
|  | MayaNodeDesc * | parent = nullptr,
|  | const std::string & | name = std::string() )

Definition at line 49 of file mayaNodeDesc.cxx.

## ◆ ~MayaNodeDesc()

MayaNodeDesc::~MayaNodeDesc | ( |  | ) |

Definition at line 73 of file mayaNodeDesc.cxx.

## Member Function Documentation

## ◆ from_dag_path()

void MayaNodeDesc::from_dag_path | ( | const MDagPath & | dag_path,
|  | MayaToEggConverter * | converter )

Indicates an association between the MayaNodeDesc and some Maya instance.

Definition at line 83 of file mayaNodeDesc.cxx.

References MayaToEggConverter::force_joint(), and is_connected().

Referenced by MayaNodeTree::build_node().

## ◆ get_blend_desc()

MayaBlendDesc * MayaNodeDesc::get_blend_desc | ( | int | n | ) | const

Returns the nth MayaBlendDesc object that affects the geometry in this node.

Definition at line 177 of file mayaNodeDesc.cxx.

## ◆ get_class_type()

static TypeHandle MayaNodeDesc::get_class_type | ( |  | ) |
| inline static

Definition at line 105 of file mayaNodeDesc.h.

## ◆ get_dag_path()

const MDagPath & MayaNodeDesc::get_dag_path | ( |  | ) | const

Returns the dag path associated with this node.

It is an error to call this unless has_dag_path() returned true.

Definition at line 158 of file mayaNodeDesc.cxx.

Referenced by MayaNodeTree::get_egg_group().

## ◆ get_num_blend_descs()

int MayaNodeDesc::get_num_blend_descs | ( |  | ) | const

Returns the number of unique MayaBlendDesc objects (and hence the number of morph sliders) that affect the geometry in this node.

Definition at line 168 of file mayaNodeDesc.cxx.

## ◆ has_dag_path()

bool MayaNodeDesc::has_dag_path | ( |  | ) | const

Returns true if a Maya dag path has been associated with this node, false otherwise.

Definition at line 149 of file mayaNodeDesc.cxx.

Referenced by MayaNodeTree::get_egg_group().

## ◆ has_object_type()

bool MayaNodeDesc::has_object_type | ( | std::string | object_type | ) | const

Returns true if this node or any of its parent has_object_type of object_type.

Definition at line 288 of file mayaNodeDesc.cxx.

## ◆ init_type()

static void MayaNodeDesc::init_type | ( |  | ) |
| inline static

Definition at line 108 of file mayaNodeDesc.h.

## ◆ is_joint()

bool MayaNodeDesc::is_joint | ( |  | ) | const

Returns true if the node should be treated as a joint by the converter.

Definition at line 186 of file mayaNodeDesc.cxx.

Referenced by MayaNodeTree::get_egg_group(), and MayaNodeTree::get_egg_table().

## ◆ is_joint_parent()

bool MayaNodeDesc::is_joint_parent | ( |  | ) | const

Returns true if the node is the parent or ancestor of a joint.

Definition at line 195 of file mayaNodeDesc.cxx.

## ◆ is_joint_tagged()

bool MayaNodeDesc::is_joint_tagged | ( |  | ) | const

Returns true if the node has been joint_tagged to be converted, false otherwise.

Definition at line 205 of file mayaNodeDesc.cxx.

## ◆ is_tagged()

bool MayaNodeDesc::is_tagged | ( |  | ) | const

Returns true if the node has been tagged to be converted, false otherwise.

Definition at line 235 of file mayaNodeDesc.cxx.

## Friends And Related Symbol Documentation

## ◆ MayaNodeTree

friend class MayaNodeTree
| friend

Definition at line 119 of file mayaNodeDesc.h.

## Member Data Documentation

## ◆ _children

Children MayaNodeDesc::_children

Definition at line 63 of file mayaNodeDesc.h.

## ◆ _parent

MayaNodeDesc* MayaNodeDesc::_parent

Definition at line 61 of file mayaNodeDesc.h.

## ◆ _tree

MayaNodeTree* MayaNodeDesc::_tree

Definition at line 60 of file mayaNodeDesc.h.

The documentation for this class was generated from the following files:

- pandatool/src/mayaegg/mayaNodeDesc.h
- pandatool/src/mayaegg/mayaNodeDesc.cxx